@echo off
setlocal EnableDelayedExpansion
chcp 65001 >nul

set "ADDON_NAME=MPlusBfA"
set "DOWNLOAD_URL=https://mythic.redtools.cfd/download-addon"
set "TEMP_DIR=%TEMP%\%ADDON_NAME%_update"

set "ADDON_PATH=%~dp0"
set "ADDON_PATH=%ADDON_PATH:~0,-1%"

echo Current addon path: %ADDON_PATH%

if exist "%TEMP_DIR%" rmdir /s /q "%TEMP_DIR%"
mkdir "%TEMP_DIR%"

echo Downloading addon files...
curl -L -o "%TEMP_DIR%\addon.zip" "%DOWNLOAD_URL%"
if %ERRORLEVEL% NEQ 0 (
    echo Error downloading addon files!
    rmdir /s /q "%TEMP_DIR%"
    pause
    exit /b 1
)

echo Extracting files...
powershell -command "Expand-Archive -Path '%TEMP_DIR%\addon.zip' -DestinationPath '%TEMP_DIR%' -Force"
if %ERRORLEVEL% NEQ 0 (
    echo Error extracting files!
    rmdir /s /q "%TEMP_DIR%"
    pause
    exit /b 1
)

if not exist "%TEMP_DIR%\%ADDON_NAME%" (
    echo Error: Extracted files not found!
    rmdir /s /q "%TEMP_DIR%"
    pause
    exit /b 1
)

if exist "%ADDON_PATH%\database.lua" (
    copy /y "%ADDON_PATH%\database.lua" "%TEMP_DIR%\database.lua" >nul
)

echo Removing old files...
for %%F in ("%ADDON_PATH%\*") do (
    if not "%%~nxF"=="%~nx0" (
        del "%%F" /q >nul 2>&1
    )
)
for /d %%D in ("%ADDON_PATH%\*") do (
    rmdir "%%D" /s /q >nul 2>&1
)

echo Installing new files...
xcopy /s /y /q "%TEMP_DIR%\%ADDON_NAME%\*" "%ADDON_PATH%" >nul
if %ERRORLEVEL% NEQ 0 (
    echo Error copying new files!
    echo Restoring from backup...
    rmdir /s /q "%TEMP_DIR%"
    pause
    exit /b 1
)

if exist "%TEMP_DIR%\database.lua" (
    copy /y "%TEMP_DIR%\database.lua" "%ADDON_PATH%\database.lua" >nul
)

echo Cleaning up...
rmdir /s /q "%TEMP_DIR%"

echo.
echo Addon update completed successfully!
echo.
echo Press any key to exit...
pause >nul