@echo off
setlocal EnableDelayedExpansion
chcp 65001 >nul

set "filename=database.lua"
set "backup_filename=database.lua.backup"
set "url=https://mythic.redtools.cfd/download"

echo Checking for existing database file...

if exist "%filename%" (
    echo Creating backup of existing database...
    copy "%filename%" "%backup_filename%" >nul
)

echo Downloading new database file...
curl -L -o "%filename%" "%url%" -I -w "%%{http_code}" 2>nul | findstr "403" >nul

if %ERRORLEVEL% EQU 0 (
    echo Error: Access Denied - 403
    echo The server is currently updating the database.
    echo Please try again in a few minutes.
    if exist "%backup_filename%" (
        echo Restoring from backup...
        copy "%backup_filename%" "%filename%" >nul
        del "%backup_filename%"
    )
    pause
    exit /b 1
)

curl -L -o "%filename%" "%url%" >nul 2>&1

if %ERRORLEVEL% EQU 0 (
    echo Download completed successfully!

    for %%A in ("%filename%") do set size=%%~zA
    if !size! LSS 1000 (
        echo Warning: Downloaded file seems too small!
        if exist "%backup_filename%" (
            echo Restoring from backup...
            copy "%backup_filename%" "%filename%" >nul
            del "%backup_filename%"
        )
    ) else (
        echo File size looks good: !size! bytes
        if exist "%backup_filename%" del "%backup_filename%"
    )
) else (
    echo Error downloading file!
    if exist "%backup_filename%" (
        echo Restoring from backup...
        copy "%backup_filename%" "%filename%" >nul
        del "%backup_filename%"
    )
    pause
    exit /b 1
)